' Demo for using the Model 20B with the Model 134

 Q = 1: REM number of thermometers - 1
 ADC = 797      'Put your ADC here
 NUMTCS = 6     'Use max of 6 for Model 20B or 14 for Model 35B. Min is 2
 DIM V(NUMTCS + 1)
 CLS
 G(0) = .8: G(1) = .8:  G(2) = .8: G(3) = .8  'put all G & K values here
 K(0) = 11.4: K(1) = 11.4: K(2) = 11.4: K(3) = 11.4
 PRINT "       Thermometer 0   Thermometer 1   Thermometer 2   Thermometer 3"
 PRINT
 FOR N = 1 TO NUMTCS: PRINT "TC # "; N: NEXT
 LOCATE 3, 13: PRINT "Wait"
 LOCATE 22, 20: PRINT "Press Esc to exit"
MAINLOOP:
 OUT ADC, 0
 FOR J = 0 TO Q
   FOR N = 0 TO NUMTCS + 1
     GOSUB READVOLTS: V(N) = VOLTS
   NEXT N
   C = (V(3) - V(0)) / K(J) - 273
   FOR N = 1 TO NUMTCS + 1
     IF N <> 3 THEN
       V = (V(N) - V(0)) * G(J)
       GOSUB LINEARIZEK
       IF N > 3 THEN L = N - 1 ELSE L = N
       LOCATE L + 2, J * 16 + 12
       PRINT USING "####.#    "; T;
     END IF
   NEXT N
 NEXT J
 IF INKEY$ <> "" THEN END ELSE GOTO MAINLOOP

READVOLTS:
 OUT ADC, J * 16 + N: REM select channel
 START = TIMER                           'ACTUAL SETTLING TIME IS 2 MILLISEC
 IF TIMER > 86399.9 THEN GOTO READVOLTS  'SHORTEST TIMER-BASED WAIT IS 60 MS
WAITSETTLE:                              'WAIT TWO TIMER TICKS
 IF TIMER < START + .06 THEN GOTO WAITSETTLE
 X = INP(ADC): REM start conversion
 TOT& = 0: AVERAGE = 100: REM set average larger for smoother data
 FOR X = 1 TO AVERAGE
WAITADC:
   IF (INP(ADC - 1) AND 2) <> 0 THEN GOTO WAITADC
   TEMP = INP(ADC + 1)
   TOT& = TOT& + TEMP * 256 + INP(ADC)
 NEXT X
 TOT& = TOT& / AVERAGE
 VOLTS = (TOT& - 32768!) * .152588
 RETURN

LINEARIZEK:
' linearize type k
 V = V + C * 4.07
 IF V < 326 THEN T = V / 4.07: RETURN
 IF V < 654 THEN T = 80 + (V - 326) / 4.11: RETURN
 IF V < 1137 THEN T = 160 + (V - 654) / 4.02: RETURN
 IF V < 1935 THEN T = 280 + (V - 1137) / 4.2: RETURN
 IF V < 2932 THEN T = 470 + (V - 1935) / 4.26: RETURN
 IF V < 3614 THEN T = 704 + (V - 2932) / 4.11: RETURN
 IF V < 4276 THEN T = 870 + (V - 3614) / 3.94: RETURN
 IF V < 4811 THEN T = 1038 + (V - 4276) / 3.77: RETURN
 IF V < 5241 THEN T = 1180 + (V - 4811) / 3.58: RETURN
 T = 1300 + (V - 5241) / 3.43: RETURN

LINEARIZET:
' linearize type t to -50 deg C
 V = V + C * 4.04
 IF V < -112 THEN T = -30 + (V + 112) / 3.53: RETURN
 IF V < 0 THEN T = V / 3.74: RETURN
 IF V < 202 THEN T = V / 4.04: RETURN
 IF V < 474 THEN T = 50 + (V - 202) / 4.53: RETURN
 IF V < 822 THEN T = 110 + (V - 474) / 4.968: RETURN
 IF V < 1256 THEN T = 180 + (V - 822) / 5.425: RETURN
 IF V < 1780 THEN T = 260 + (V - 1256) / 5.825: RETURN
 T = 350 + (V - 1780) / 6.15: RETURN

LINEARIZEE:
' linearize type e
 V = V + C * 6.1
 IF V < 366 THEN T = V / 6.1: RETURN
 IF V < 836 THEN T = 60 + (V - 366) / 6.72: RETURN
 IF V < 1487 THEN T = 130 + (V - 836) / 7.223: RETURN
 IF V < 2494 THEN T = 220 + (V - 1487) / 7.74: RETURN
 IF V < 5633 THEN T = 350 + (V - 2494) / 8.049: RETURN
 IF V < 6878 THEN T = 740 + (V - 5633) / 7.785: RETURN
 T = 900 + (V - 6878) / 7.6: RETURN

LINEARIZEJ:
' linearize type j
 V = V + C * 5.2
 IF V < 411 THEN T = V / 5.2: RETURN
 IF V < 2738 THEN T = 79 + (V - 411) / 5.527: RETURN
 IF V < 3367 THEN T = 500 + (V - 2738) / 5.72: RETURN
 IF V < 3911 THEN T = 610 + (V - 3367) / 6.05: RETURN
 T = 700 + (V - 3911) / 6.33: RETURN

